diff --git a/include/linux/sched.h b/include/linux/sched.h
index ed6c384..e75b309 100644
--- a/include/linux/sched.h
+++ b/include/linux/sched.h
@@ -147,13 +147,19 @@ extern void calc_global_load(unsigned long ticks);
 extern unsigned long get_parent_ip(unsigned long addr);
 
 struct seq_file;
+#ifdef CONFIG_SCHED_FAIR_CFS
 struct cfs_rq;
+#elif CONFIG_SCHED_FAIR_HTFS
+struct htfs_rqs;
+#endif
 struct task_group;
 #ifdef CONFIG_SCHED_DEBUG
 extern void proc_sched_show_task(struct task_struct *p, struct seq_file *m);
 extern void proc_sched_set_task(struct task_struct *p);
+#ifdef CONFIG_SCHED_FAIR_CFS
 extern void
 print_cfs_rq(struct seq_file *m, int cpu, struct cfs_rq *cfs_rq);
+#endif
 #else
 static inline void
 proc_sched_show_task(struct task_struct *p, struct seq_file *m)
@@ -162,11 +168,13 @@ proc_sched_show_task(struct task_struct *p, struct seq_file *m)
 static inline void proc_sched_set_task(struct task_struct *p)
 {
 }
+#ifdef CONFIG_SCHED_FAIR_CFS
 static inline void
 print_cfs_rq(struct seq_file *m, int cpu, struct cfs_rq *cfs_rq)
 {
 }
 #endif
+#endif
 
 /*
  * Task state bitmask. NOTE! These bits are also
@@ -1049,6 +1057,7 @@ struct sched_domain;
 #define ENQUEUE_WAKEUP		1
 #define ENQUEUE_WAKING		2
 #define ENQUEUE_HEAD		4
+#define ENQUEUE_PRESERVE_INTERACTIVITY	8
 
 #define DEQUEUE_SLEEP		1
 
@@ -1139,12 +1148,49 @@ struct sched_statistics {
 };
 #endif
 
+#ifdef CONFIG_SCHED_FAIR_HTFS
+
+#define HTFS_LAST_VTIME_STATE 3
+
+#define HTFS_VTIME_DIFF_INIT		0x00
+#define HTFS_VTIME_DIFF_INIT2		0x01
+#define HTFS_VTIME_DIFF_OK		0x02
+
+#define HTFS_PREEMPTED			0x04
+#define HTFS_NEED_INTERQ		0x08
+
+#endif
+
 struct sched_entity {
 	struct load_weight	load;		/* for load-balancing */
-	struct rb_node		run_node;
+#ifdef CONFIG_SCHED_FAIR_CFS
 	struct list_head	group_node;
+#endif
 	unsigned int		on_rq;
 
+#ifdef CONFIG_SCHED_FAIR_CFS
+	struct rb_node		run_node;
+#elif CONFIG_SCHED_FAIR_HTFS
+	/*
+	 * item on the priorityqueue list
+	 */
+	struct list_head	htfs_pq_item;
+	struct htfs_rq		*htfs_rq;	// FIXME: replace by relative addressing?
+	/*
+	 * state of the entity to reduce the number of calculations and comparisons
+	 */
+	u32			htfs_state;
+
+	/*
+	 * boosted weight to correct vruntime
+	 */
+	unsigned int		bw_ind;
+
+	u64			wakeup_time;
+
+	s64			last_vdiff;
+#endif
+
 	u64			exec_start;
 	u64			sum_exec_runtime;
 	u64			vruntime;
@@ -1159,10 +1205,25 @@ struct sched_entity {
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	struct sched_entity	*parent;
 	/* rq on which this entity is (to be) queued: */
+#ifdef CONFIG_SCHED_FAIR_CFS
 	struct cfs_rq		*cfs_rq;
 	/* rq "owned" by this entity/group: */
 	struct cfs_rq		*my_q;
+#elif CONFIG_SCHED_FAIR_HTFS
+	struct list_head group_node;
+	struct htfs_rqs		*htfs_rqs;
+	/* rq "owned" by this entity/group: */
+	struct htfs_rqs		*my_q;
+#ifdef CONFIG_SMP
+	/*
+	 * interactivity value to balance interactive tasks
+	 */
+	unsigned long inter;
+	unsigned long inter_avg;
+	unsigned long load_avg;
 #endif
+#endif /* CONFIG_SCHED_FAIR_HTFS */
+#endif /* CONFIG_FAIR_GROUP_SCHED */
 };
 
 struct sched_rt_entity {
@@ -1283,9 +1344,9 @@ struct task_struct {
 	unsigned long stack_canary;
 #endif
 
-	/* 
+	/*
 	 * pointers to (original) parent process, youngest child, younger sibling,
-	 * older sibling, respectively.  (p->father can be replaced with 
+	 * older sibling, respectively.  (p->father can be replaced with
 	 * p->real_parent->pid)
 	 */
 	struct task_struct *real_parent; /* real parent process */
@@ -1906,6 +1967,7 @@ extern void wake_up_idle_cpu(int cpu);
 static inline void wake_up_idle_cpu(int cpu) { }
 #endif
 
+#ifdef CONFIG_SCHED_FAIR_CFS
 extern unsigned int sysctl_sched_latency;
 extern unsigned int sysctl_sched_min_granularity;
 extern unsigned int sysctl_sched_wakeup_granularity;
@@ -1918,6 +1980,11 @@ enum sched_tunable_scaling {
 	SCHED_TUNABLESCALING_END,
 };
 extern enum sched_tunable_scaling sysctl_sched_tunable_scaling;
+#elif CONFIG_SCHED_FAIR_HTFS
+extern unsigned int sysctl_sched_inter_slice_shift;
+extern u64 sysctl_sched_inter_latency;
+extern unsigned int sysctl_sched_slice_max_shift;
+#endif
 
 #ifdef CONFIG_SCHED_DEBUG
 extern unsigned int sysctl_sched_migration_cost;
@@ -1925,11 +1992,11 @@ extern unsigned int sysctl_sched_nr_migrate;
 extern unsigned int sysctl_sched_time_avg;
 extern unsigned int sysctl_timer_migration;
 extern unsigned int sysctl_sched_shares_window;
+#endif
 
 int sched_proc_update_handler(struct ctl_table *table, int write,
 		void __user *buffer, size_t *length,
 		loff_t *ppos);
-#endif
 #ifdef CONFIG_SCHED_DEBUG
 static inline unsigned int get_sysctl_timer_migration(void)
 {
@@ -2083,7 +2150,7 @@ static inline int dequeue_signal_lock(struct task_struct *tsk, sigset_t *mask, s
 	spin_unlock_irqrestore(&tsk->sighand->siglock, flags);
 
 	return ret;
-}	
+}
 
 extern void block_all_signals(int (*notifier)(void *priv), void *priv,
 			      sigset_t *mask);
diff --git a/init/Kconfig b/init/Kconfig
index 47dd02f..3569cfb 100644
--- a/init/Kconfig
+++ b/init/Kconfig
@@ -797,6 +797,23 @@ config NET_NS
 
 endif # NAMESPACES
 
+choice
+	prompt "Fair CPU Scheduler"
+	default SCHED_FAIR_CFS
+
+config SCHED_FAIR_CFS
+	bool "Completely Fair Scheduler (CFS)"
+	help
+	  This scheduler is really fair, but has time complexity O(log n).
+
+config SCHED_FAIR_HTFS
+	bool "High Throughput Fair Scheduler (HTFS)"
+	help
+	  HTFS aims at high throughput systems with high counts of
+	  processes. Time complexity is only O(1).
+
+endchoice
+
 config SCHED_AUTOGROUP
 	bool "Automatic process group scheduling"
 	select EVENTFD
diff --git a/kernel/sched.c b/kernel/sched.c
index c164920..1e09a3b 100644
--- a/kernel/sched.c
+++ b/kernel/sched.c
@@ -253,7 +253,11 @@ struct task_group {
 	/* schedulable entities of this group on each cpu */
 	struct sched_entity **se;
 	/* runqueue "owned" by this group on each cpu */
+#ifdef CONFIG_SCHED_FAIR_CFS
 	struct cfs_rq **cfs_rq;
+#elif CONFIG_SCHED_FAIR_HTFS
+	struct htfs_rqs **htfs_rqs;
+#endif
 	unsigned long shares;
 
 	atomic_t load_weight;
@@ -306,6 +310,8 @@ struct task_group root_task_group;
 
 #endif	/* CONFIG_CGROUP_SCHED */
 
+#ifdef CONFIG_SCHED_FAIR_CFS
+
 /* CFS-related fields in a runqueue */
 struct cfs_rq {
 	struct load_weight load;
@@ -373,6 +379,89 @@ struct cfs_rq {
 #endif
 };
 
+#elif CONFIG_SCHED_FAIR_HTFS /* CONFIG_SCHED_FAIR_CFS */
+
+struct htfs_rq;
+struct htfs_rqs;
+
+struct htfs_pq {
+	struct list_head spqs_real_weight;
+	struct list_head queue;
+
+	// real weight of all queued entities
+	unsigned long real_bweight;
+
+	unsigned long balance_ct;
+};
+
+struct htfs_rq {
+	//s64 badness; no use for this right now
+	unsigned long bweight;
+	unsigned long run_cost;
+	struct htfs_pq *cur_pq;
+
+	struct list_head spqs_real_weight;
+
+	// 40 queues to match the priorities + 1 queue for shutdown + 2 max/min
+	struct htfs_pq pqs[50];
+
+	struct htfs_rqs *rqs;
+};
+
+struct htfs_rqs {
+	struct htfs_rq interq;
+	struct htfs_rq normalq;
+	unsigned long nr_running;
+	struct rq *rq;
+
+	int dbg_counter;
+
+	long rq_balance_ct;
+
+
+	u64 vtime;
+	unsigned long inv_weight;
+
+	unsigned long weight;
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+	struct list_head tasks;
+	/*
+	 * leaf htfs_rqs are those that hold tasks (lowest schedulable entity in
+	 * a hierarchy). Non-leaf lrqs hold other higher schedulable entities
+	 * (like users, containers etc.)
+	 *
+	 * leaf_htfs_rqs_list ties together list of leaf htfs_rqs in a cpu. This
+	 * list is used during load balance.
+	 */
+	int on_list;
+	struct list_head leaf_htfs_rqs_list;
+	struct task_group *tg;	/* group that "owns" this runqueue */
+
+	unsigned long h_load;
+#ifdef CONFIG_SMP
+
+	u64 offline_start;
+	/*
+	 * sum of the real load of all SEs on this queue
+	 */
+	u64 load;
+	u64 load_avg;
+	u64 load_period;
+	u64 load_stamp, load_last, load_unacc_exec_time;
+	unsigned long load_contribution;
+
+	/*
+	 * interactivity values for balancing
+	 */
+	unsigned long inter;
+	unsigned long inter_avg;
+#endif
+#endif
+};
+
+#endif /* CONFIG_SCHED_FAIR_HTFS */
+
 /* Real-Time classes' related field in a runqueue: */
 struct rt_rq {
 	struct rt_prio_array active;
@@ -468,12 +557,36 @@ struct rq {
 	unsigned long nr_load_updates;
 	u64 nr_switches;
 
+#ifdef CONFIG_SCHED_FAIR_CFS
 	struct cfs_rq cfs;
+#elif CONFIG_SCHED_FAIR_HTFS
+	struct htfs_rqs htfs_rqs;
+#endif
 	struct rt_rq rt;
 
 #ifdef CONFIG_FAIR_GROUP_SCHED
 	/* list of leaf cfs_rq on this cpu: */
+#ifdef CONFIG_SCHED_FAIR_CFS
 	struct list_head leaf_cfs_rq_list;
+#elif CONFIG_SCHED_FAIR_HTFS
+	struct list_head leaf_htfs_rqs_list;
+	u64 slice;
+	unsigned int slice_shift;
+
+	u64 slice_granted;
+	u64 slice_remain;
+
+	u64 slice_change_last;
+	unsigned long slice_shrink; // Indicator if we should shrink the timeslice
+	u64 slice_shrink_last_dec; // Last indicator reset/decrease
+	
+	u64 last_call;
+	u64 call_time_diff;
+	struct task_struct *continue_run;
+	int force_sched;
+	int continues;
+#endif
+
 #endif
 #ifdef CONFIG_RT_GROUP_SCHED
 	struct list_head leaf_rt_rq_list;
@@ -620,8 +733,13 @@ static inline struct task_group *task_group(struct task_struct *p)
 static inline void set_task_rq(struct task_struct *p, unsigned int cpu)
 {
 #ifdef CONFIG_FAIR_GROUP_SCHED
+#ifdef CONFIG_SCHED_FAIR_CFS
 	p->se.cfs_rq = task_group(p)->cfs_rq[cpu];
 	p->se.parent = task_group(p)->se[cpu];
+#elif CONFIG_SCHED_FAIR_HTFS
+	p->se.htfs_rqs = task_group(p)->htfs_rqs[cpu];
+	p->se.parent = task_group(p)->se[cpu];
+#endif
 #endif
 
 #ifdef CONFIG_RT_GROUP_SCHED
@@ -1303,6 +1421,15 @@ static void sched_avg_update(struct rq *rq)
  */
 #define SRR(x, y) (((x) + (1UL << ((y) - 1))) >> (y))
 
+static inline unsigned long calc_inv_weight(unsigned long weight)
+{
+	if (BITS_PER_LONG > 32 && unlikely(weight >= WMULT_CONST))
+		return 1;
+	else
+		return (1 + (WMULT_CONST-weight/2)
+				/ (weight+1));
+}
+
 /*
  * delta *= weight / lw
  */
@@ -1313,11 +1440,7 @@ calc_delta_mine(unsigned long delta_exec, unsigned long weight,
 	u64 tmp;
 
 	if (!lw->inv_weight) {
-		if (BITS_PER_LONG > 32 && unlikely(lw->weight >= WMULT_CONST))
-			lw->inv_weight = 1;
-		else
-			lw->inv_weight = 1 + (WMULT_CONST-lw->weight/2)
-				/ (lw->weight+1);
+		lw->inv_weight = calc_inv_weight(lw->weight);
 	}
 
 	tmp = (u64)delta_exec * weight;
@@ -1537,38 +1660,6 @@ static unsigned long cpu_avg_load_per_task(int cpu)
 	return rq->avg_load_per_task;
 }
 
-#ifdef CONFIG_FAIR_GROUP_SCHED
-
-/*
- * Compute the cpu's hierarchical load factor for each task group.
- * This needs to be done in a top-down fashion because the load of a child
- * group is a fraction of its parents load.
- */
-static int tg_load_down(struct task_group *tg, void *data)
-{
-	unsigned long load;
-	long cpu = (long)data;
-
-	if (!tg->parent) {
-		load = cpu_rq(cpu)->load.weight;
-	} else {
-		load = tg->parent->cfs_rq[cpu]->h_load;
-		load *= tg->se[cpu]->load.weight;
-		load /= tg->parent->cfs_rq[cpu]->load.weight + 1;
-	}
-
-	tg->cfs_rq[cpu]->h_load = load;
-
-	return 0;
-}
-
-static void update_h_load(long cpu)
-{
-	walk_tg_tree(tg_load_down, tg_nop, (void *)cpu);
-}
-
-#endif
-
 #ifdef CONFIG_PREEMPT
 
 static void double_rq_lock(struct rq *rq1, struct rq *rq2);
@@ -1690,7 +1781,9 @@ static void double_rq_unlock(struct rq *rq1, struct rq *rq2)
 
 static void calc_load_account_idle(struct rq *this_rq);
 static void update_sysctl(void);
+#ifdef CONFIG_SCHED_FAIR_CFS
 static int get_update_sysctl_factor(void);
+#endif
 static void update_cpu_load(struct rq *this_rq);
 
 static inline void __set_task_cpu(struct task_struct *p, unsigned int cpu)
@@ -2061,6 +2154,23 @@ static void check_preempt_curr(struct rq *rq, struct task_struct *p, int flags)
 }
 
 #ifdef CONFIG_SMP
+
+#ifdef CONFIG_SCHED_FAIR_CFS
+
+static int fair_se_is_first_last(struct sched_entity *se)
+{
+	return (se == cfs_rq_of(se)->next || se == cfs_rq_of(se)->last);
+}
+
+#elif CONFIG_SCHED_FAIR_HTFS
+
+static int fair_se_is_first_last(struct sched_entity *se)
+{
+	//TODO:
+	return 0;
+}
+#endif
+
 /*
  * Is this task likely cache-hot:
  */
@@ -2079,8 +2189,7 @@ task_hot(struct task_struct *p, u64 now, struct sched_domain *sd)
 	 * Buddy candidates are cache hot:
 	 */
 	if (sched_feat(CACHE_HOT_BUDDY) && this_rq()->nr_running &&
-			(&p->se == cfs_rq_of(&p->se)->next ||
-			 &p->se == cfs_rq_of(&p->se)->last))
+			fair_se_is_first_last(&p->se))
 		return 1;
 
 	if (sysctl_sched_migration_cost == -1)
@@ -3900,6 +4009,22 @@ static void put_prev_task(struct rq *rq, struct task_struct *prev)
 	prev->sched_class->put_prev_task(rq, prev);
 }
 
+#ifdef CONFIG_SCHED_FAIR_CFS
+
+static inline int tasks_all_fair_class(struct rq *rq)
+{
+	return likely(rq->nr_running == rq->cfs.nr_running);
+}
+
+#elif CONFIG_SCHED_FAIR_HTFS
+
+static inline int tasks_all_fair_class(struct rq *rq)
+{
+	return likely(rq->nr_running == rq->htfs_rqs.nr_running);
+}
+
+#endif
+
 /*
  * Pick up the highest-prio task:
  */
@@ -3913,7 +4038,7 @@ pick_next_task(struct rq *rq)
 	 * Optimization: we know that if all tasks are in
 	 * the fair class we can call that function directly:
 	 */
-	if (likely(rq->nr_running == rq->cfs.nr_running)) {
+	if (likely(tasks_all_fair_class(rq))) {
 		p = fair_sched_class.pick_next_task(rq);
 		if (likely(p))
 			return p;
@@ -5584,6 +5709,7 @@ void __cpuinit init_idle(struct task_struct *idle, int cpu)
  */
 cpumask_var_t nohz_cpu_mask;
 
+#ifdef CONFIG_SCHED_FAIR_CFS
 /*
  * Increase the granularity value when there are more CPUs,
  * because with more CPUs the 'effective latency' as visible
@@ -5625,6 +5751,11 @@ static void update_sysctl(void)
 	SET_SYSCTL(sched_wakeup_granularity);
 #undef SET_SYSCTL
 }
+#else
+static void update_sysctl(void)
+{
+}
+#endif /* CONFIG_SCHED_FAIR_CFS */
 
 static inline void sched_init_granularity(void)
 {
@@ -7790,7 +7921,7 @@ int in_sched_functions(unsigned long addr)
 		(addr >= (unsigned long)__sched_text_start
 		&& addr < (unsigned long)__sched_text_end);
 }
-
+#ifdef CONFIG_SCHED_FAIR_CFS
 static void init_cfs_rq(struct cfs_rq *cfs_rq, struct rq *rq)
 {
 	cfs_rq->tasks_timeline = RB_ROOT;
@@ -7800,6 +7931,46 @@ static void init_cfs_rq(struct cfs_rq *cfs_rq, struct rq *rq)
 #endif
 	cfs_rq->min_vruntime = (u64)(-(1LL << 20));
 }
+#elif CONFIG_SCHED_FAIR_HTFS
+
+static void init_htfs_pq(struct htfs_pq *pq, struct htfs_rq *rq)
+{
+	INIT_LIST_HEAD(&pq->spqs_real_weight);
+	INIT_LIST_HEAD(&pq->queue);
+	pq->real_bweight = 0;
+	pq->balance_ct = 0;
+}
+static void init_htfs_rq(struct htfs_rq *rq, struct htfs_rqs *rqs)
+{
+	int i = 50;
+	rq->bweight = 0;
+	rq->cur_pq = NULL;
+
+	INIT_LIST_HEAD(&rq->spqs_real_weight);
+
+	while (i--) {
+		init_htfs_pq(&rq->pqs[i], rq);
+	}
+	rq->rqs = rqs;
+}
+
+static void init_htfs_rqs(struct htfs_rqs *rqs, struct rq *rq)
+{
+	init_htfs_rq(&rqs->interq, rqs);
+	init_htfs_rq(&rqs->normalq, rqs);
+	rqs->nr_running = 0;
+	rqs->rq = rq;
+	rqs->dbg_counter = 0;
+	rqs->rq_balance_ct = 0;
+	rqs->vtime = 0; //TODO: perhaps in relation to the vtimes on other rqs
+	rqs->load_avg = 0;
+	rqs->load = 0;
+	rqs->offline_start = rq->clock;
+	rqs->weight = 0;
+	rqs->inv_weight = 0;
+	INIT_LIST_HEAD(&rqs->tasks);
+}
+#endif
 
 static void init_rt_rq(struct rt_rq *rt_rq, struct rq *rq)
 {
@@ -7838,6 +8009,8 @@ static void init_rt_rq(struct rt_rq *rt_rq, struct rq *rq)
 }
 
 #ifdef CONFIG_FAIR_GROUP_SCHED
+
+#ifdef CONFIG_SCHED_FAIR_CFS
 static void init_tg_cfs_entry(struct task_group *tg, struct cfs_rq *cfs_rq,
 				struct sched_entity *se, int cpu,
 				struct sched_entity *parent)
@@ -7861,8 +8034,34 @@ static void init_tg_cfs_entry(struct task_group *tg, struct cfs_rq *cfs_rq,
 	update_load_set(&se->load, 0);
 	se->parent = parent;
 }
+#elif CONFIG_SCHED_FAIR_HTFS
+static void init_tg_htfs_entry(struct task_group *tg, struct htfs_rqs *rqs,
+				struct sched_entity *se, int cpu,
+				struct sched_entity *parent)
+{
+	struct rq *rq = cpu_rq(cpu);
+	tg->htfs_rqs[cpu] = rqs;
+	init_htfs_rqs(rqs, rq);
+	rqs->tg = tg;
+
+	tg->se[cpu] = se;
+	/* se could be NULL for root_task_group */
+	if (!se)
+		return;
+
+	if (!parent)
+		se->htfs_rqs = &rq->htfs_rqs;
+	else
+		se->htfs_rqs = parent->my_q;
+
+	se->my_q = rqs;
+	update_load_set(&se->load, 0);
+	se->parent = parent;
+}
 #endif
 
+#endif /* CONFIG_FAIR_GROUP_SCHED */
+
 #ifdef CONFIG_RT_GROUP_SCHED
 static void init_tg_rt_entry(struct task_group *tg, struct rt_rq *rt_rq,
 		struct sched_rt_entity *rt_se, int cpu,
@@ -7910,8 +8109,11 @@ void __init sched_init(void)
 #ifdef CONFIG_FAIR_GROUP_SCHED
 		root_task_group.se = (struct sched_entity **)ptr;
 		ptr += nr_cpu_ids * sizeof(void **);
-
+#ifdef CONFIG_SCHED_FAIR_CFS
 		root_task_group.cfs_rq = (struct cfs_rq **)ptr;
+#elif CONFIG_SCHED_FAIR_HTFS
+		root_task_group.htfs_rqs = (struct htfs_rqs **)ptr;
+#endif
 		ptr += nr_cpu_ids * sizeof(void **);
 
 #endif /* CONFIG_FAIR_GROUP_SCHED */
@@ -7957,10 +8159,27 @@ void __init sched_init(void)
 		rq->nr_running = 0;
 		rq->calc_load_active = 0;
 		rq->calc_load_update = jiffies + LOAD_FREQ;
+#ifdef CONFIG_SCHED_FAIR_CFS
 		init_cfs_rq(&rq->cfs, rq);
+#elif CONFIG_SCHED_FAIR_HTFS
+		init_htfs_rqs(&rq->htfs_rqs, rq);
+		rq->slice_shift = 20;
+		rq->slice = (1UL << rq->slice_shift);
+		rq->slice_granted = rq->slice;
+		rq->slice_remain = 0;
+		rq->slice_change_last = 0;
+		rq->slice_shrink = 0;
+		rq->slice_shrink_last_dec = 0;
+		rq->last_call = 0;
+		rq->call_time_diff = 0;
+		rq->continue_run = NULL;
+		rq->force_sched = 0;
+		rq->continues = 0;
+#endif
 		init_rt_rq(&rq->rt, rq);
 #ifdef CONFIG_FAIR_GROUP_SCHED
 		root_task_group.shares = root_task_group_load;
+#ifdef CONFIG_SCHED_FAIR_CFS
 		INIT_LIST_HEAD(&rq->leaf_cfs_rq_list);
 		/*
 		 * How much cpu bandwidth does root_task_group get?
@@ -7982,6 +8201,11 @@ void __init sched_init(void)
 		 * directly in rq->cfs (i.e root_task_group->se[] = NULL).
 		 */
 		init_tg_cfs_entry(&root_task_group, &rq->cfs, NULL, i, NULL);
+#elif CONFIG_SCHED_FAIR_HTFS
+		INIT_LIST_HEAD(&rq->leaf_htfs_rqs_list);
+		init_tg_htfs_entry(&root_task_group, &rq->htfs_rqs, NULL, i, NULL);
+#endif
+
 #endif /* CONFIG_FAIR_GROUP_SCHED */
 
 		rq->rt.rt_runtime = def_rt_bandwidth.rt_runtime;
@@ -8215,6 +8439,7 @@ void set_curr_task(int cpu, struct task_struct *p)
 #endif
 
 #ifdef CONFIG_FAIR_GROUP_SCHED
+#ifdef CONFIG_SCHED_FAIR_CFS
 static void free_fair_sched_group(struct task_group *tg)
 {
 	int i;
@@ -8287,6 +8512,81 @@ static inline void unregister_fair_sched_group(struct task_group *tg, int cpu)
 	list_del_leaf_cfs_rq(tg->cfs_rq[cpu]);
 	raw_spin_unlock_irqrestore(&rq->lock, flags);
 }
+#elif CONFIG_SCHED_FAIR_HTFS
+static void free_fair_sched_group(struct task_group *tg)
+{
+	int i;
+
+	for_each_possible_cpu(i) {
+		if (tg->htfs_rqs)
+			kfree(tg->htfs_rqs[i]);
+		if (tg->se)
+			kfree(tg->se[i]);
+	}
+
+	kfree(tg->htfs_rqs);
+	kfree(tg->se);
+}
+
+static
+int alloc_fair_sched_group(struct task_group *tg, struct task_group *parent)
+{
+	struct htfs_rqs *rqs;
+	struct sched_entity *se;
+	struct rq *rq;
+	int i;
+
+	tg->htfs_rqs = kzalloc(sizeof(rqs) * nr_cpu_ids, GFP_KERNEL);
+	if (!tg->htfs_rqs)
+		goto err;
+	tg->se = kzalloc(sizeof(se) * nr_cpu_ids, GFP_KERNEL);
+	if (!tg->se)
+		goto err;
+
+	tg->shares = NICE_0_LOAD;
+
+	for_each_possible_cpu(i) {
+		rq = cpu_rq(i);
+
+		rqs = kzalloc_node(sizeof(struct htfs_rqs),
+				      GFP_KERNEL, cpu_to_node(i));
+		if (!rqs)
+			goto err;
+
+		se = kzalloc_node(sizeof(struct sched_entity),
+				  GFP_KERNEL, cpu_to_node(i));
+		if (!se)
+			goto err_free_rq;
+
+		init_tg_htfs_entry(tg, rqs, se, i, parent->se[i]);
+	}
+
+	return 1;
+
+err_free_rq:
+	kfree(rqs);
+err:
+	return 0;
+}
+
+static inline void unregister_fair_sched_group(struct task_group *tg, int cpu)
+{
+	struct rq *rq = cpu_rq(cpu);
+	unsigned long flags;
+
+	/*
+	* Only empty task groups can be destroyed; so we can speculatively
+	* check on_list without danger of it being re-added.
+	*/
+	if (!tg->htfs_rqs[cpu]->on_list)
+		return;
+
+	raw_spin_lock_irqsave(&rq->lock, flags);
+	list_del_leaf_htfs_rqs(tg->htfs_rqs[cpu]);
+	raw_spin_unlock_irqrestore(&rq->lock, flags);
+}
+
+#endif /* CONFIG_SCHED_FAIR_HTFS */
 #else /* !CONFG_FAIR_GROUP_SCHED */
 static inline void free_fair_sched_group(struct task_group *tg)
 {
@@ -8510,8 +8810,13 @@ int sched_group_set_shares(struct task_group *tg, unsigned long shares)
 		se = tg->se[i];
 		/* Propagate contribution to hierarchy */
 		raw_spin_lock_irqsave(&rq->lock, flags);
-		for_each_sched_entity(se)
+		for_each_sched_entity(se) {
+#ifdef CONFIG_SCHED_FAIR_CFS
 			update_cfs_shares(group_cfs_rq(se), 0);
+#elif CONFIG_SCHED_FAIR_HTFS
+			update_htfs_shares(group_htfs_rqs(se));
+#endif
+		}
 		raw_spin_unlock_irqrestore(&rq->lock, flags);
 	}
 
diff --git a/kernel/sched_debug.c b/kernel/sched_debug.c
index eb6cb8e..55797fe 100644
--- a/kernel/sched_debug.c
+++ b/kernel/sched_debug.c
@@ -56,7 +56,7 @@ static unsigned long nsec_low(unsigned long long nsec)
 #define SPLIT_NS(x) nsec_high(x), nsec_low(x)
 
 #ifdef CONFIG_FAIR_GROUP_SCHED
-static void print_cfs_group_stats(struct seq_file *m, int cpu, struct task_group *tg)
+static void print_fair_group_stats(struct seq_file *m, int cpu, struct task_group *tg)
 {
 	struct sched_entity *se = tg->se[cpu];
 	if (!se)
@@ -83,6 +83,14 @@ static void print_cfs_group_stats(struct seq_file *m, int cpu, struct task_group
 	P(se->statistics.wait_count);
 #endif
 	P(se->load.weight);
+#ifdef CONFIG_SCHED_FAIR_HTFS
+	P(se->bw_ind);
+	P(se->inter);
+	P(se->inter_avg);
+	P(se->load.weight);
+	P(se->load_avg);
+	P(se->vruntime);
+#endif
 #undef PN
 #undef P
 }
@@ -130,6 +138,9 @@ print_task(struct seq_file *m, struct rq *rq, struct task_struct *p)
 	SEQ_printf(m, "%15Ld %15Ld %15Ld.%06ld %15Ld.%06ld %15Ld.%06ld",
 		0LL, 0LL, 0LL, 0L, 0LL, 0L, 0LL, 0L);
 #endif
+	SEQ_printf(m, "%d %u %u",
+		se_is_on_interq(&p->se),
+		p->se.htfs_state, p->se.bw_ind);
 #ifdef CONFIG_CGROUP_SCHED
 	SEQ_printf(m, " %s", task_group_path(task_group(p)));
 #endif
@@ -161,6 +172,8 @@ static void print_rq(struct seq_file *m, struct rq *rq, int rq_cpu)
 	read_unlock_irqrestore(&tasklist_lock, flags);
 }
 
+#ifdef CONFIG_SCHED_FAIR_CFS
+
 void print_cfs_rq(struct seq_file *m, int cpu, struct cfs_rq *cfs_rq)
 {
 	s64 MIN_vruntime = -1, min_vruntime, max_vruntime = -1,
@@ -214,10 +227,63 @@ void print_cfs_rq(struct seq_file *m, int cpu, struct cfs_rq *cfs_rq)
 			atomic_read(&cfs_rq->tg->load_weight));
 #endif
 
-	print_cfs_group_stats(m, cpu, cfs_rq->tg);
+	print_fair_group_stats(m, cpu, cfs_rq->tg);
+#endif
+}
+
+#elif CONFIG_SCHED_FAIR_HTFS /* CONFIG_SCHED_FAIR_CFS */
+
+void print_htfs_pq(struct seq_file *m, struct htfs_pq *pq)
+{
+	SEQ_printf(m, "      .%-30s: %lu\n", "real_bweight", pq->real_bweight);
+	SEQ_printf(m, "      .%-30s: %lu\n", "balance_ct", pq->balance_ct);
+}
+
+void print_htfs_rq(struct seq_file *m, struct htfs_rq *rq)
+{
+	struct htfs_pq *pq, *tmp;
+	SEQ_printf(m, "    .%-30s: %lu\n", "bweight", rq->bweight);
+	SEQ_printf(m, "    .%-30s: %lu\n", "run_cost", rq->run_cost);
+	list_for_each_entry_safe_reverse(pq, tmp, &rq->spqs_real_weight, spqs_real_weight) {
+		SEQ_printf(m, "    .pqs\n");
+		print_htfs_pq(m, pq);
+	}
+}
+
+void print_htfs_rqs(struct seq_file *m, int cpu, struct htfs_rqs *rqs)
+{
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+	SEQ_printf(m, "\nhtfs_rqs[%d]:%s\n", cpu, task_group_path(rqs->tg));
+#else
+	SEQ_printf(m, "\nhtfs_rqs[%d]:\n", cpu);
+#endif
+	SEQ_printf(m, "  .%-30s: %ld\n", "nr_running", rqs->nr_running);
+	SEQ_printf(m, "  .%-30s: %ld\n", "rq_balance_ct", rqs->rq_balance_ct);
+	SEQ_printf(m, "  .%-30s: %llu\n", "vtime", rqs->vtime);
+	SEQ_printf(m, "  .%-30s: %lu\n", "inv_weight", rqs->inv_weight);
+	SEQ_printf(m, "  .%-30s: %lu\n", "weight", rqs->weight);
+#ifdef CONFIG_FAIR_GROUP_SCHED
+	SEQ_printf(m, "  .%-30s: %d\n", "on_list", rqs->on_list);
+	SEQ_printf(m, "  .%-30s: %lu\n", "h_load", rqs->h_load);
+#ifdef CONFIG_SMP
+	SEQ_printf(m, "  .%-30s: %llu\n", "offline_start", rqs->offline_start);
+	SEQ_printf(m, "  .%-30s: %lu\n", "load", rqs->load);
+	SEQ_printf(m, "  .%-30s: %lu\n", "load_avg", rqs->load_avg);
+	SEQ_printf(m, "  .%-30s: %lu\n", "load_contribution", rqs->load_contribution);
+	SEQ_printf(m, "  .%-30s: %lu\n", "inter", rqs->inter);
+	SEQ_printf(m, "  .%-30s: %lu\n", "inter_avg", rqs->inter_avg);
 #endif
+	print_fair_group_stats(m, cpu, rqs->tg);
+#endif
+	SEQ_printf(m, "  .normalq\n");
+	print_htfs_rq(m, &rqs->normalq);
+	SEQ_printf(m, "  .interq\n");
+	print_htfs_rq(m, &rqs->interq);
 }
 
+#endif /* CONFIG_SCHED_FAIR_HTFS */
+
 void print_rt_rq(struct seq_file *m, int cpu, struct rt_rq *rt_rq)
 {
 #ifdef CONFIG_RT_GROUP_SCHED
@@ -277,6 +343,15 @@ static void print_cpu(struct seq_file *m, int cpu)
 	P(cpu_load[2]);
 	P(cpu_load[3]);
 	P(cpu_load[4]);
+#ifdef CONFIG_SCHED_FAIR_HTFS
+	P(slice);
+	P(slice_shift);
+	P(slice_granted);
+	P(slice_remain);
+	P(slice_change_last);
+	P(slice_shrink);
+	P(slice_shrink_last_dec);
+#endif
 #undef P
 #undef PN
 
@@ -303,7 +378,11 @@ static void print_cpu(struct seq_file *m, int cpu)
 #undef P64
 #endif
 	spin_lock_irqsave(&sched_debug_lock, flags);
+#ifdef CONFIG_SCHED_FAIR_CFS
 	print_cfs_stats(m, cpu);
+#elif CONFIG_SCHED_FAIR_HTFS
+	print_htfs_stats(m, cpu);
+#endif
 	print_rt_stats(m, cpu);
 
 	rcu_read_lock();
@@ -312,11 +391,13 @@ static void print_cpu(struct seq_file *m, int cpu)
 	spin_unlock_irqrestore(&sched_debug_lock, flags);
 }
 
+#ifdef CONFIG_SCHED_FAIR_CFS
 static const char *sched_tunable_scaling_names[] = {
 	"none",
 	"logaritmic",
 	"linear"
 };
+#endif
 
 static int sched_debug_show(struct seq_file *m, void *v)
 {
@@ -352,6 +433,7 @@ static int sched_debug_show(struct seq_file *m, void *v)
 	SEQ_printf(m, "\n");
 	SEQ_printf(m, "sysctl_sched\n");
 
+#ifdef CONFIG_FAIR_SCHED_CFS
 #define P(x) \
 	SEQ_printf(m, "  .%-40s: %Ld\n", #x, (long long)(x))
 #define PN(x) \
@@ -367,7 +449,7 @@ static int sched_debug_show(struct seq_file *m, void *v)
 	SEQ_printf(m, "  .%-40s: %d (%s)\n", "sysctl_sched_tunable_scaling",
 		sysctl_sched_tunable_scaling,
 		sched_tunable_scaling_names[sysctl_sched_tunable_scaling]);
-
+#endif
 	for_each_online_cpu(cpu)
 		print_cpu(m, cpu);
 
